
(define (domain mirror-ninja)
    (:requirements :strips :equality)
  (:types location ninja mirror step)
  (:predicates 
   (at-ninja ?n - ninja ?loc - location)
   (at-mirror ?n - mirror ?loc - location)
   (adjacent-north ?loc1 ?loc2 - location)
   (adjacent-south ?loc1 ?loc2 - location)
   (adjacent-east ?loc1 ?loc2 - location)
   (adjacent-west ?loc1 ?loc2 - location)

   (finished-step ?step - step ?loc - location)
   (predecessor ?step ?step1 - step ?loc - location)
   (project-finished ?n - ninja ?loc - location)
   )
  
  (:action project-step
	   :parameters ( ?n - ninja ?loc - location ?step - step)
	   :precondition (and
			  (at-ninja ?n ?loc)
			  (predecessor ?step step0 ?loc)
			  (finished-step step0 ?loc)
			  (not (finished-step ?step ?loc))
			  )
	   :effect (and
		    (finished-step ?step ?loc)))

      (:action finish-project
	       :parameters ( ?n - ninja ?loc - location)
	       :precondition (and
			    (finished-step step1 ?loc)
			    (finished-step step2 ?loc)
			    (finished-step step3 ?loc)
			    )

	       :effect (and
			(project-finished ?n ?loc)))

  (:action move-north
	   :parameters (?n - ninja ?cn - mirror ?from ?to - location
			   ?loc ?loc-to - location)
	   :precondition (and
			  (project-finished ?n ?from)
			  (at-ninja ?n ?from)
			  (at-mirror ?cn ?loc)
			  (not (= ?n ?cn))
			  (adjacent-north ?from ?to)
			  (adjacent-south ?loc ?loc-to))
	   :effect (and
		    (not (at-ninja ?n ?from))
		    (at-ninja ?n ?to)
		    (not (at-mirror ?cn ?loc))
		    (at-mirror ?cn ?loc-to)))
		    
  (:action move-south
	   :parameters (?n - ninja ?cn - mirror ?from ?to - location
			   ?loc ?loc-to - location)
	   :precondition (and
			  (project-finished ?n ?from)
			  (at-ninja ?n ?from)
			  (at-mirror ?cn ?loc)
			  (not (= ?n ?cn))						  
			  (adjacent-south ?from ?to)
			  (adjacent-north ?loc ?loc-to))
	   :effect (and
		    (not (at-ninja ?n ?from))
		    (at-ninja ?n ?to)
		    (not (at-mirror ?cn ?loc))
		    (at-mirror ?cn ?loc-to)))

  (:action move-east
	   :parameters (?n - ninja ?cn - mirror ?from ?to - location
			   ?loc ?loc-to - location)
	   :precondition (and
			  (project-finished ?n ?from)
			  (at-ninja ?n ?from)
			  (at-mirror ?cn ?loc)
			  (not (= ?n ?cn))
			  (adjacent-east ?from ?to)
			  (adjacent-east ?loc ?loc-to))
	   :effect (and
		    (not (at-ninja ?n ?from))
		    (at-ninja ?n ?to)
		    (not (at-mirror ?cn ?loc))
		    (at-mirror ?cn ?loc-to)))

  (:action move-west
	   :parameters (?n - ninja ?cn - mirror ?from ?to - location
			   ?loc ?loc-to - location)
	   :precondition (and
			  (project-finished ?n ?from)
			  (at-ninja ?n ?from)
			  (at-mirror ?cn ?loc)
			  (not (= ?n ?cn))
			  (adjacent-west ?from ?to)
			  (adjacent-west ?loc ?loc-to))
	   :effect (and
		    (not (at-ninja ?n ?from))
		    (at-ninja ?n ?to)
		    (not (at-mirror ?cn ?loc))
		    (at-mirror ?cn ?loc-to)))
  )
